#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;
use obbuild;

$default_permissions = 0777;  ### DEFAULT PERMISSIONS THAT IS USED FOR FILES ON 

&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

##################################################################################

print "Content-type: text/html\n\n";
if ($q->param('fct') eq "") {&start;}
if ($q->param('fct') eq "add_template") {&add_template;}
if ($q->param('fct') eq "add_template_final") {&add_template_final;}
if ($q->param('fct') eq "delete") {&delete_customt;}
if ($q->param('fct') eq "edit") {&add_template;}
if ($q->param('fct') eq "save_edited_template") {&save_edited_template;}
if ($q->param('fct') eq "inuse") {&where_inuse;}
if ($q->param('fct') eq "assign") {&assign_to_cats;}
if ($q->param('fct') eq "assign_ids") {&assign_ids;}
if ($q->param('fct') eq "preview") {&preview;}


##################################################################################

sub preview
{
$ctmpl = $q->param('ctmpl');

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }
 
$sql = "SELECT * FROM dirs WHERE template = '$ctmpl' ORDER BY level ASC LIMIT 0, 1";
$sth = $dbh->prepare($sql);
if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n"; }
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}

	while ( @row = $sth->fetchrow() )
	{ 
	$cid = $row[0];
	}

$sth->finish;
$dbh->disconnect; 


if ($cid eq "")
	{
	acs::problem_popup("Unable to Preview. The reason for this is that no categories has this template assigned. To assign a custom template to a category
	go to the 'Dir Manager' tab and click on 'Default' under the 'Template Column' next to any category.");
	}
	else
	{
	print qq[
	<html>
	<head>
	<title>FocalMedia.Net Support</title>
	<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$script_url/dirs2.cgi?cid=$cid">
	</head>
	<body>
	</body>
	</html>
	];
	}

}




sub assign_ids
{


if ($q->param('related_categories') eq "")
	{
	acs::problem_popup("You have to at least provide one category ID.");
	}

$ctmpl = $q->param('ctmpl');

$ids = $q->param('related_categories');
$ids =~ s/ //g;

@all_ids = split(/,/,$ids);

foreach $item (@all_ids)
	{
	if ($item > 0)
		{
		$where_sql = $where_sql . " (cid = '$item') OR";
		}
	}

$where_sql = substr($where_sql, 0, length($where_sql) -2);


if ($q->param('default_template') eq "Y")
	{
	$ctmpl = "";
	}


if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }
 
$sql = "UPDATE dirs SET template = '$ctmpl' WHERE $where_sql";

$sth = $dbh->prepare($sql);
if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n"; }
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}

$sth->finish;
$dbh->disconnect; 


######################


if ($ctmpl eq ""){$ctmpl = "Default";}


######################


$headi_display = acs::get_heading_box("$web_url/ic_dirs.gif", "$ctmpl Templates Assigned to Categories/Directories", qq[
Template <strong>$ctmpl </strong>has been assigned to the categories/directories according to the category/directory ID's you have specified. 
<BR><a href="$admin_url/admin27.cgi">Click here to continue.</a>
]);



print <<END_OF_CTS;

<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>

$headi_display

</body>
</html>

END_OF_CTS

}





sub assign_to_cats
{

$ctmpl = $q->param('ctmpl');
$ctml = $q->param('ctmpl');


$headi_display = acs::get_heading_box("$web_url/ic_dirs.gif", "Assign Custom Template Sets to Categories/Directories", qq[
This section enables you to assign custom templates to categories/directories via category/directory ID's. Each category/directory in the Directory has a unique ID.
<BR><a href="$admin_url/admin27.cgi"><b>Go Back</b></a>
]);


print <<END_OF_STC;

<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">


<script LANGUAGE="JavaScript">
<!-- Hide

  function popup(loc,ww,hh)
   {
    var mywidth = (ww + 0);
    var myheight = (hh + 0);
    var myspecs = "'menubar=0,status=1,resizable=1,location=0,titlebar=1,toolbar=1,scrollbars=1,width=" + mywidth + ",height=" + myheight + "'";
	var random = parseInt(Math.random()*10000)

	  var popupwin = null;
      myWindow = open (loc, popupwin + random, myspecs);
      myWindow.moveTo(400,0);
      myWindow.focus();

    }
    
   
 // End Hide -->
 </script>


</head>
<body>
$headi_display

<form method="POST" action="$admin_url/admin27.cgi" name="addu">
  <table border="0" cellpadding="6" width="100%" style="border: 1px solid rgb(221,221,221)" cellspacing="1">
    <tr>
      <td height="30" valign="top" background="$web_url/bar6.gif" class="normaltext"><strong>Please provide the category ID's where the custom
      tempate $ctml will be assigned to below: </strong></td>
    </tr>
    <tr>
      <td width="101%" valign="top" class="normaltext">(Seperate id's via comma. For example: 123,42,4234,4,43): &nbsp; <br>
      <input type="text" name="related_categories" size="77"> 
       <a href="$admin_url/admin67.cgi?fct=related"  onClick="popup('$admin_url/admin67.cgi?fct=related',800,600);return false;"><strong>Browser (to assign IDs)</strong></a><br>
      'You can also get category/directory ID's by clicking on the 'Tree + Stats' link when in the
      'Dir Manager' </td>
    </tr>
    <tr>
      <td width="101%" valign="top" class="normaltext"><input type="checkbox" name="default_template" value="Y"> Do
      not assign <strong>$ctml </strong>and assign the <strong>default </strong>template
      instead. Check this box, only if you want to assign the default directory template to
      categories. </td>
    </tr>
    <tr>
      <td width="101%" valign="top" class="normaltext"><input type="submit" value="Assign $ctmpl to Categories" name="B1">
        <input type="hidden" name="fct" value="assign_ids">
        <input type="hidden" name="ctmpl" value="$ctmpl"></td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font> </td>
      <td width="99%"></td>
    </tr>
  </table>
</form>

</body>
</html>

END_OF_STC




}




sub where_inuse
{

$ctmpl = $q->param('ctmpl');

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }
 
$sql = "SELECT * FROM dirs WHERE template = '$ctmpl'";

$sth = $dbh->prepare($sql);
if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n"; }
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}

	$cat_counter = 0;
	while ( @row = $sth->fetchrow() )
	{ 
	$cats = ""; $lvc = 0; $enc_cat = "";
	for ($ms = 2; $ms < 18; $ms++) 
		{
		if ($row[$ms] ne "")
			{
			$cats = $cats . qq[ $row[$ms] ] . " : ";
			$enc_cat = $enc_cat . acs::encode_dir($row[$ms]) . "-";
			$lvc++;
			}
		
		}
		
		$cats = substr($cats, 0, length($cats) - 2);
		chop($enc_cat);
		##$cats = $cats . " <b>ID=$row[0]</b>";
		
		
		
		@all_cats[$cat_counter] = qq[[ <a href="$admin_url/admin2.cgi?fct=edit_dir&lv=$lvc&ct=$enc_cat&cid=$row[0]" target="_blank"> Edit </a> | <a href="$admin_url/admin12.cgi?ct=$enc_cat&fct=gotocat&cid=$row[0]" target="_blank"> Admin </a> | <a href="$script_url/dirs.cgi?lv=$lvc&ct=$enc_cat&cid=$row[0]" target="_blank">Preview</a> ] $cats];
	
	$cat_counter++;
	}
 
$sth->finish;
$dbh->disconnect; 


###############


$headi_display = acs::get_heading_box("$web_url/ic_dirs.gif", "Custom Category/Directory Template Set In Use:", qq[
This section shows you where the Custom Template Set <b>'$ctmpl'</b> is in use.
<BR>
<a href="$admin_url/admin27.cgi"><b>Go Back</b></a>
]);






###################

@all_cats = sort(@all_cats);

foreach $item (@all_cats)
	{
	$clist = $clist . "$item <br>";
	}

############

if ($cat_counter == 0) { $nthing = "This template is not in use in any categories/directories"; }


print <<END_OF_PG;

<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>

$headi_display

<span class="normaltext">
$nthing
$clist
</span>

</body>
</html>

END_OF_PG



}




sub save_edited_template
{

$tname = $q->param('tname');

$filename = "$data_dir/$tname-1ctst.html";
open (CTMPL, "> $filename");
	print CTMPL $q->param('defdir');
close (CTMPL);
$stat = chmod($default_permissions,"$filename","$filename"); 


$filename = "$data_dir/$tname-2ctst.html";
open (CTMPL, "> $filename");
	print CTMPL $q->param('tmplsearch');
close (CTMPL);
$stat = chmod($default_permissions,"$filename","$filename"); 


$filename = "$data_dir/$tname-3ctst.html";
open (CTMPL, "> $filename");
	print CTMPL $q->param('subdirs');
close (CTMPL);
$stat = chmod($default_permissions,"$filename","$filename"); 


$filename = "$data_dir/$tname-4ctst.html";
open (CTMPL, "> $filename");
	print CTMPL $q->param('directories1');
close (CTMPL);
$stat = chmod($default_permissions,"$filename","$filename"); 


$filename = "$data_dir/$tname-5ctst.html";
open (CTMPL, "> $filename");
	print CTMPL $q->param('related1');
close (CTMPL);
$stat = chmod($default_permissions,"$filename","$filename"); 


$filename = "$data_dir/$tname-6ctst.html";
open (CTMPL, "> $filename");
	print CTMPL $q->param('related2');
close (CTMPL);
$stat = chmod($default_permissions,"$filename","$filename"); 


$filename = "$data_dir/$tname-7ctst.html";
open (CTMPL, "> $filename");
	print CTMPL $q->param('linkinfo');
close (CTMPL);
$stat = chmod($default_permissions,"$filename","$filename"); 

$filename = "$data_dir/$tname-8ctst.html";
open (CTMPL, "> $filename");
	print CTMPL $q->param('tmplsearch_prem');
close (CTMPL);
$stat = chmod($default_permissions,"$filename","$filename"); 


$filename = "$data_dir/$tname-9ctst.html";
open (CTMPL, "> $filename");
	print CTMPL $q->param('linkinfop');
close (CTMPL);
$stat = chmod($default_permissions,"$filename","$filename"); 



$headi_display = acs::get_heading_box("$web_url/ic_dirs.gif", "Custom Category/Directory Template Set Saved", qq[
<a href="$admin_url/admin27.cgi">Click here to continue.</a>
]);


print <<END_OF_CUST;

<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$headi_display
</body>
</html>

END_OF_CUST

}




sub delete_customt
{

$ctmpl = $q->param('ctmpl');

$filename = "$data_dir/$ctmpl" . "-1ctst.html";
$stat = unlink ($filename);

$filename = "$data_dir/$ctmpl" . "-2ctst.html";
$stat = unlink ($filename);

$filename = "$data_dir/$ctmpl" . "-3ctst.html";
$stat = unlink ($filename);

$filename = "$data_dir/$ctmpl" . "-4ctst.html";
$stat = unlink ($filename);

$filename = "$data_dir/$ctmpl" . "-5ctst.html";
$stat = unlink ($filename);

$filename = "$data_dir/$ctmpl" . "-6ctst.html";
$stat = unlink ($filename);

$filename = "$data_dir/$ctmpl" . "-7ctst.html";
$stat = unlink ($filename);

$filename = "$data_dir/$ctmpl" . "-8ctst.html";
$stat = unlink ($filename);



$headi_display = acs::get_heading_box("$web_url/ic_dirs.gif", "Custom Category/Directory Template Set Deleted", qq[
<a href="$admin_url/admin27.cgi">Click here to continue.</a>
]);


print <<END_OF_CUST;

<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$headi_display
</body>
</html>


END_OF_CUST



}






sub add_template_final
{

for ($ms = 0; $ms < length($q->param('ctemplate_name')); $ms++) 
	{
	$oneletter = substr($q->param('ctemplate_name'), $ms, 1);
	if (($oneletter !~ /[0-9a-zA-Z]/) and ($oneletter ne "_"))
		{
		acs::problem_popup("The custom-template-set name you specified contains invalid characters. Please use only numerical characters or characters present in the english alphabet.");
		}
	} 

	if ($q->param('ctemplate_name') eq "")
		{
		acs::problem_popup("You have to supply a name for the custom templates you are about to create."); 
		}

#### CHECK FOR DUPLICATES

$filename = "$data_dir/" . $q->param('ctemplate_name') . "-1ctst.html";
if (-e "$filename")
	{ 
	acs::problem_popup("There is already a custom-template-set by the name you have chosen for the new custom-template-set.");
	}

############

open (CTMPL, "> $filename");
	print CTMPL $q->param('defdir');
close (CTMPL);
$stat = chmod($default_permissions,"$filename","$filename"); 


$filename = "$data_dir/" . $q->param('ctemplate_name') . "-2ctst.html";
open (CTMPL, "> $filename");
	print CTMPL $q->param('tmplsearch');
close (CTMPL);
$stat = chmod($default_permissions,"$filename","$filename"); 


$filename = "$data_dir/" . $q->param('ctemplate_name') . "-3ctst.html";
open (CTMPL, "> $filename");
	print CTMPL $q->param('subdirs');
close (CTMPL);
$stat = chmod($default_permissions,"$filename","$filename"); 


$filename = "$data_dir/" . $q->param('ctemplate_name') . "-4ctst.html";
open (CTMPL, "> $filename");
	print CTMPL $q->param('directories1');
close (CTMPL);
$stat = chmod($default_permissions,"$filename","$filename"); 


$filename = "$data_dir/" . $q->param('ctemplate_name') . "-5ctst.html";
open (CTMPL, "> $filename");
	print CTMPL $q->param('related1');
close (CTMPL);
$stat = chmod($default_permissions,"$filename","$filename"); 


$filename = "$data_dir/" . $q->param('ctemplate_name') . "-6ctst.html";
open (CTMPL, "> $filename");
	print CTMPL $q->param('related2');
close (CTMPL);
$stat = chmod($default_permissions,"$filename","$filename"); 


$filename = "$data_dir/" . $q->param('ctemplate_name') . "-7ctst.html";
open (CTMPL, "> $filename");
	print CTMPL $q->param('linkinfo');
close (CTMPL);
$stat = chmod($default_permissions,"$filename","$filename"); 


$filename = "$data_dir/" . $q->param('ctemplate_name') . "-8ctst.html";
open (CTMPL, "> $filename");
	print CTMPL $q->param('tmplsearch_prem');
close (CTMPL);
$stat = chmod($default_permissions,"$filename","$filename"); 


$filename = "$data_dir/" . $q->param('ctemplate_name') . "-9ctst.html";
open (CTMPL, "> $filename");
	print CTMPL $q->param('linkinfop');
close (CTMPL);
$stat = chmod($default_permissions,"$filename","$filename"); 


###########################


$headi_display = acs::get_heading_box("$web_url/ic_dirs.gif", "Custom Category/Directory Template Set Created", qq[
<a href="$admin_url/admin27.cgi">Click here to continue.</a>
]);



print <<END_OF_CUST;

<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$headi_display
</body>
</html>

END_OF_CUST

}





sub add_template
{

if ($q->param('fct') eq "edit") 
	{
	$ctmpl = $q->param('ctmpl');
	$defdir = acs::get_file_contents("$data_dir/$ctmpl-1ctst.html");
	$tmplsearch = acs::get_file_contents("$data_dir/$ctmpl-2ctst.html");
	
	$tmplsearch_prem = acs::get_file_contents("$data_dir/$ctmpl-8ctst.html");
	
	$subdirs = acs::get_file_contents("$data_dir/$ctmpl-3ctst.html");
	$directories1 = acs::get_file_contents("$data_dir/$ctmpl-4ctst.html");
	
	$related1 = acs::get_file_contents("$data_dir/$ctmpl-5ctst.html");
	$related2 = acs::get_file_contents("$data_dir/$ctmpl-6ctst.html");
	
	$linkinfo = acs::get_file_contents("$data_dir/$ctmpl-7ctst.html");
	$linkinfop = acs::get_file_contents("$data_dir/$ctmpl-9ctst.html");



$top_page = acs::get_heading_box("$web_url/ic_dirs.gif", "Edit Custom Category/Directory Template Set", qq[
A custom category/directory template set consists of 9 templates. These 9 templates are combined into one to form pages of categories/directories where this template set has been assigned to.
]);


$edit_or_create = <<END_OF_EDC0;
<table border="0" width="100%" cellspacing="1" cellpadding="6"
style="border: 1px solid rgb(221,221,221)">
  <tr>
    <td width="100%" valign="top" class="normaltext" background="$web_url/bar6.gif"><strong>Name
    of New Custom Category/Directory Template Set: <font color="#0000FF">$ctmpl</font></strong></td>
  </tr>
</table>

<table border="0" cellpadding="0" cellspacing="0" width="100%"
background="$web_url/shadow.gif">
  <tr>
    <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
    <td width="99%"></td>
  </tr>
</table>
END_OF_EDC0
	
	$form_action = "save_edited_template";
	$button_text = "Save Custom Template Set";
	$ltext = "Editing a Custom Directory Template Set";
	$template_nm = "<input type=\"hidden\" name=\"tname\" value=\"$ctmpl\">"
	
	}
	else
	{
	
	$defdir = acs::get_file_contents("$data_dir/defdir.html");
	$tmplsearch = acs::get_file_contents("$data_dir/tmplsearch.html");
	$tmplsearch_prem = acs::get_file_contents("$data_dir/tmplsearch_prem.html");
	$subdirs = acs::get_file_contents("$data_dir/subdirs.html");
	$directories1 = acs::get_file_contents("$data_dir/directories1.html");

	$related1 = acs::get_file_contents("$data_dir/related1.html");
	$related2 = acs::get_file_contents("$data_dir/related2.html");

	$linkinfo = acs::get_file_contents("$data_dir/linkinfo.html");
	$linkinfop = acs::get_file_contents("$data_dir/linkinfop.html");


$top_page = acs::get_heading_box("$web_url/ic_dirs.gif", "Create Custom Category/Directory Template Set", qq[
A custom category/directory template set consists of 9 templates. These 9 templates are combined into one to form pages of categories/directories where this template can be assigned to.
<BR>
<strong><a href="$admin_url/admin27.cgi">Go Back</a></strong>
]);


$edit_or_create = <<END_OF_EDC;

<table border="0" width="100%" cellspacing="1" cellpadding="6"
style="border: 1px solid rgb(221,221,221)">
  <tr>
    <td width="100%" valign="top" class="normaltext" background="$web_url/bar6.gif"><strong>Name
    of New Custom Category/Directory Template Set:</strong></td>
  </tr>
  <tr>
    <td width="100%" valign="top" class="normaltext"><input type="text" name="ctemplate_name"
    size="40" maxlength="50"> <strong>(Required) </strong><br>
    Only use english alphabetical or numerical characters for the name of the template set you
    are about to create. You may also make use of underscore characters. </td>
  </tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%"
background="$web_url/shadow.gif">
  <tr>
    <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
    <td width="99%"></td>
  </tr>
</table>

END_OF_EDC

	$form_action = "add_template_final";
	$button_text = "Add New Custom Template Set";
	}



print <<END_OF_AC;
<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
<form method="POST" action="$admin_url/admin27.cgi">
  <input type="hidden" name="fct" value="$form_action"><p>$template_nm </p>
  
  $top_page
  
  $edit_or_create
  
 
<table border="0" width="100%" cellspacing="1" cellpadding="8"
style="border: 1px solid rgb(221,221,221)">
  <tr>
    <td height="30" background="$web_url/bar6.gif"><strong class="normaltext">Main Category/Directory Template: </strong></td>
  </tr>
  <tr>
    <td><table border="0" cellpadding="0" cellspacing="0" width="100%">
      <tr>
        <td width="99%" class="normaltext">This is the main template used when displaying listings in
        categories/directories.<br>
        <a href="$admin_url/admin6.cgi?template=defdir&amp;fct=tinfo" target="_blank">Click here
        to see which variables are available for use in this template</a></td>
        <td width="1%" valign="bottom">
        <input type="button" value="    Select All    " name="B5" onClick="javascript:this.form.defdir.focus();this.form.defdir.select(); return false;">        </td>
      </tr>
    </table>
    <p><textarea rows="13" name="defdir" cols="101" style="width:100%">
$defdir
</textarea> </td>
  </tr>
</table>



  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
      <td width="99%"></td>
    </tr>
  </table>
  

  

<table border="0" width="100%" cellspacing="1" cellpadding="8"
style="border: 1px solid rgb(221,221,221)">
  <tr>
    <td height="30" background="$web_url/bar6.gif"><strong class="normaltext">Link Style: </strong></td>
  </tr>
  <tr>
    <td><table border="0" cellpadding="0" cellspacing="0" width="100%">
      <tr>
        <td width="99%" class="normaltext">This template reflects the HTML code used when displaying link listings in   directories/categories. <br>
          <a href="$admin_url/admin6.cgi?template=tmplsearch&fct=tinfo" target="_blank">Click   here to see which variables are available for use in this template </a></td>
        <td width="1%" valign="bottom">
        <input type="button" value="    Select All    " name="B5" onClick="javascript:this.form.tmplsearch.focus();this.form.tmplsearch.select(); return false;">        </td>
      </tr>
    </table>
    <p>
      <textarea rows="13" name="tmplsearch" cols="101"  style="width:100%">$tmplsearch</textarea>
    </td>
  </tr>
</table>
  
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
      <td width="99%"></td>
    </tr>
  </table>


  
 
 <table border="0" width="100%" cellspacing="1" cellpadding="8"
 style="border: 1px solid rgb(221,221,221)">
   <tr>
     <td height="30" background="$web_url/bar6.gif"><strong class="normaltext">Premium Link Style:</strong></td>
   </tr>
   <tr>
     <td><table border="0" cellpadding="0" cellspacing="0" width="100%">
       <tr>
         <td width="99%" class="normaltext">This template reflects the HTML code that is used when displaying premium link listings in   directories/categories. If this template is left blank, the premium links will inherit the   style of the default link style template. <br>
           <a href="$admin_url/admin6.cgi?template=tmplsearch_prem&fct=tinfo" target="_blank">Click   here to see which variables are available for use in this template </a></td>
         <td width="1%" valign="bottom">
         <input type="button" value="    Select All    " name="B5" onClick="javascript:this.form.tmplsearch_prem.focus();this.form.tmplsearch_prem.select(); return false;">        </td>
       </tr>
     </table>
     <p>
       <textarea rows="13" name="tmplsearch_prem" cols="101"  style="width:100%">$tmplsearch_prem</textarea>
     </td>
   </tr>
 </table>

  
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
      <td width="99%"></td>
    </tr>
  </table>
  

  
<table border="0" width="100%" cellspacing="1" cellpadding="8"
style="border: 1px solid rgb(221,221,221)">
  <tr>
    <td height="30" background="$web_url/bar6.gif"><strong class="normaltext">Sub Directories/Categories Style 1:</strong></td>
  </tr>
  <tr>
    <td><table border="0" cellpadding="0" cellspacing="0" width="100%">
      <tr>
        <td width="99%" class="normaltext">This template is used to display categories/directories <br>
          <a href="$admin_url/admin6.cgi?template=subdirs&fct=tinfo" target="_blank">Click here   to see which variables are available for use in this template </a></td>
        <td width="1%" valign="bottom">
        <input type="button" value="    Select All    " name="B5" onClick="javascript:this.form.subdirs.focus();this.form.subdirs.select(); return false;">        </td>
      </tr>
    </table>
    <p>
      <textarea rows="13" name="subdirs" cols="101"  style="width:100%">$subdirs</textarea>
    </td>
  </tr>
</table>
  
  
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
      <td width="99%"></td>
    </tr>
  </table>
  
  

<table border="0" width="100%" cellspacing="1" cellpadding="8"
style="border: 1px solid rgb(221,221,221)">
  <tr>
    <td height="30" background="$web_url/bar6.gif"><strong class="normaltext">Sub Directories/Categories Style 2:</strong></td>
  </tr>
  <tr>
    <td><table border="0" cellpadding="0" cellspacing="0" width="100%">
      <tr>
        <td width="99%" class="normaltext">This template is used to display directories/categories <br>
          <a href="$admin_url/admin6.cgi?template=directories1&fct=tinfo" target="_blank">Click   here to see which variables are available for use in this template </a></td>
        <td width="1%" valign="bottom">
        <input type="button" value="    Select All    " name="B5" onClick="javascript:this.form.directories1.focus();this.form.directories1.select(); return false;">        </td>
      </tr>
    </table>
    <p>
      <textarea rows="13" name="directories1" cols="101" style="width:100%">$directories1</textarea>
    </td>
  </tr>
</table>

  
  <table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
      <td width="99%"></td>
    </tr>
  </table>

  
<table border="0" width="100%" cellspacing="1" cellpadding="8"
style="border: 1px solid rgb(221,221,221)">
  <tr>
    <td height="30" background="$web_url/bar6.gif"><strong class="normaltext">Related Directories/Categories Style 1:</strong></td>
  </tr>
  <tr>
    <td><table border="0" cellpadding="0" cellspacing="0" width="100%">
      <tr>
        <td width="99%" class="normaltext">This template is used to display related links. <br>
          <a href="$admin_url/admin6.cgi?template=related1&fct=tinfo" target="_blank">Click here   to see which variables are available for use in this template </a></td>
        <td width="1%" valign="bottom">
        <input type="button" value="    Select All    " name="B5" onClick="javascript:this.form.related1.focus();this.form.related1.select(); return false;">        </td>
      </tr>
    </table>
    <p>
      <textarea rows="5" name="related1" cols="101"  style="width:100%">$related1</textarea>
    </td>
  </tr>
</table>

  
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
      <td width="99%"></td>
    </tr>
  </table>
  
  
 
 <table border="0" width="100%" cellspacing="1" cellpadding="8"
 style="border: 1px solid rgb(221,221,221)">
   <tr>
     <td height="30" background="$web_url/bar6.gif"><strong class="normaltext">Related Directories/Categories Style 2:</strong></td>
   </tr>
   <tr>
     <td><table border="0" cellpadding="0" cellspacing="0" width="100%">
       <tr>
         <td width="99%" class="normaltext">This template is used to display related links. <br>
           <a href="$admin_url/admin6.cgi?template=related2&fct=tinfo" target="_blank">Click here   to see which variables are available for use in this template</a></td>
         <td width="1%" valign="bottom">
         <input type="button" value="    Select All    " name="B5" onClick="javascript:this.form.related2.focus();this.form.related2.select(); return false;">        </td>
       </tr>
     </table>
     <p>
       <textarea rows="5" name="related2" cols="101"  style="width:100%">$related2</textarea>
     </td> 
   </tr>
 </table>

 

  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
      <td width="99%"></td>
    </tr>
  </table>

  

<table border="0" width="100%" cellspacing="1" cellpadding="8"
style="border: 1px solid rgb(221,221,221)">
  <tr>
    <td height="30" background="$web_url/bar6.gif"><strong class="normaltext">Link Info:</strong></td>
  </tr>
  <tr>
    <td><table border="0" cellpadding="0" cellspacing="0" width="100%">
      <tr>
        <td width="99%" class="normaltext">This template is used to display a page for each link. You can, for example, have an extra   page with extra field/key information for each link. You link to this extra page from the   Link Style Template (tmplsearch.html) - See the documentation for more information on   this. <br>
          <a href="$admin_url/admin6.cgi?template=linkinfo&fct=tinfo" target="_blank">Click here   to see which variables are available for use in this template </a></td>
        <td width="1%" valign="bottom">
        <input type="button" value="    Select All    " name="B5" onClick="javascript:this.form.linkinfo.focus();this.form.linkinfo.select(); return false;">        </td>
      </tr>
    </table>
    <p>
      <textarea rows="13" name="linkinfo" cols="101"  style="width:100%">$linkinfo</textarea>
    </td> 
  </tr>
</table>

  
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
      <td width="99%"></td>
    </tr>
  </table>


  

<table border="0" width="100%" cellspacing="1" cellpadding="8"
style="border: 1px solid rgb(221,221,221)">
  <tr>
    <td height="30" background="$web_url/bar6.gif"><strong class="normaltext">Link Info Premium:</strong></td>
  </tr>
  <tr>
    <td><table border="0" cellpadding="0" cellspacing="0" width="100%">
      <tr>
        <td width="99%" class="normaltext">This template is used to display a page for each premium link. You can, for example, have   an extra page with extra field/key information for each link. You link to this extra page   from the Link Style Template (tmplsearch.html) - See the documentation for more   information on this. <br>
          <a href="$admin_url/admin6.cgi?template=linkinfop&fct=tinfo" target="_blank">Click   here to see which variables are available for use in this template </a></td>
        <td width="1%" valign="bottom">
        <input type="button" value="    Select All    " name="B5" onClick="javascript:this.form.linkinfop.focus();this.form.linkinfop.select(); return false;">        </td>
      </tr>
    </table>
    <p>
      <textarea rows="13" name="linkinfop" cols="101"  style="width:100%">$linkinfop</textarea>
    </td> 
  </tr>
</table>

  
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
      <td width="99%"></td>
    </tr>
  </table>
  
<table border="0" cellpadding="3" cellspacing="0" width="100%">
  <tr>
    <td width="1%"><img src="$web_url/butarrow.gif"></td>
    <td width="99%" valign="bottom"><input type="submit" value="$button_text" name="B1"></td>
  </tr>
</table>
<BR><BR>
  
</form>
</body>
</html>

END_OF_AC

}





sub start
{


$hbox = acs::get_heading_box("$web_url/ic_dirs.gif", "Create/Edit/Delete Custom Category/Directory Templates", qq[
The templates you create here can be used in different categories. Once you created a custom template it is selectable 
when you are in the 'Dir Manager'. Each category in the 'Dir Manager' has a 'Template' option. 
Click on the option (Example: 'Default') to choose a set of templates to use for a specific category.
]);


print <<END_OF_EM;

<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>

$hbox

<table border="0" cellpadding="6" width="100%" style="border: 1px solid rgb(221,221,221)" cellspacing="1">
  <tr>
    <td width="98%" height="30" valign="top" class="normaltext" bgcolor="#F4F4F4" colspan="6" background="$web_url/bar6.gif"><strong>Custom Category/Directory Templates Available: </strong></td>
  </tr>
  <tr>
    <td width="30%" height="30" valign="top" class="normaltext" bgcolor="#F4F4F4"><strong>Name: </strong></td>
    <td width="10%" height="30" align="center" valign="top" class="normaltext" bgcolor="#F4F4F4"><strong>Edit </strong></td>
    <td width="10%" height="30" align="center" valign="top" class="normaltext" bgcolor="#F4F4F4"><strong>Delete</strong></td>
    <td width="10%" height="30" align="center" valign="top" class="normaltext" bgcolor="#F4F4F4"><strong>Preview</strong></td>
    <td width="20%" height="30" align="center" valign="top" class="normaltext" bgcolor="#F4F4F4"><strong>Where it's in use:</strong></td>
    <td width="20%" height="30" align="center" valign="top" class="normaltext" bgcolor="#F4F4F4"><strong>Assign to Categories: </strong></td>
  </tr>
END_OF_EM

#####################


if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }
 

opendir(DIR,"$data_dir");
	@files = readdir(DIR);
	@files = sort(@files);
	foreach $filename (@files)
		{
		if (substr($filename, length($filename) - 11, 11) eq "-1ctst\.html")
			{
			
			$cust_tmpl_name = substr($filename, 0, length($filename) - 11);
			
			$sql = "SELECT COUNT(*) FROM dirs WHERE template = '$cust_tmpl_name'";
			$sth = $dbh->prepare($sql);
			$sth->execute;
			$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $querystr";} 
			while ( @row = $sth->fetchrow() ) { $totalnr = $row[0]; }  
 

$cust_list = $cust_list . <<END_OFL;
  <tr  onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td width="30%" valign="top" class="normaltext"><b>$cust_tmpl_name </b></td>
    <td width="10%" align="center" valign="top" class="normaltext"><a href="$admin_url/admin27.cgi?fct=edit&amp;ctmpl=$cust_tmpl_name">Edit </a></td>
    <td width="10%" align="center" valign="top" class="normaltext"><a href="$admin_url/admin27.cgi?fct=delete&amp;ctmpl=$cust_tmpl_name">Delete </a></td>
    <td width="10%" align="center" valign="top" class="normaltext"><a href="$admin_url/admin27.cgi?fct=preview&amp;ctmpl=$cust_tmpl_name" target="_blank">Preview </a></td>
    <td width="20%" align="center" valign="top" class="normaltext"><a href="$admin_url/admin27.cgi?fct=inuse&amp;ctmpl=$cust_tmpl_name">Where in use </a>($totalnr)</td>
    <td width="20%" align="center" valign="top" class="normaltext"><a href="$admin_url/admin27.cgi?fct=assign&amp;ctmpl=$cust_tmpl_name">Assign to Categories </a></td>
  </tr>
END_OFL
			
			}
		} 


if ( defined $sth )
	{
	$sth->finish;
	}
$dbh->disconnect;




if ($cust_list eq "")
{
$cust_list = $cust_list . <<END_OF_NOC;
<tr>
 <td width="31%" valign="top" colspan="5" class="normaltext">No custom templates have been created.</td>
</tr>
END_OF_NOC

}



$helpb = acs::quick_help("Quick Help",qq[

<ul>
  <li>
    
    <span class="normaltext">The number in brackets next to the 'Where in use' link indicates the number of categories where the 'custom category' template set is in use.  </span></li>
  <li class="normaltext">Choose 'Assign to Categories' to assign the custom category template set to specific categories.</li>
</ul>

]);  



$cust_list = $cust_list . <<END_OFB;


</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
  <tr>
    <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
    <td width="99%"></td>
  </tr>
</table>

<form method="POST" action="$admin_url/admin27.cgi">
  <input type="hidden" name="fct" value="add_template"><input type="submit"   value="Add New Category/Directory Template" name="B1">
</form>

$helpb

</body>
</html>

END_OFB

print $cust_list;

}


####################################################################################


sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

